import random
import time

def tri_selection(L):
    """ 1 seul argument qui est un tableau ou une liste , L
    la fonction renvoie (return) la liste L triée
    Test :
    >>> L = [3, 1, 4, 1, 5, 9, 2]
    >>> tri_selection(L)
    >>> L == [1, 1, 2, 3, 4, 5, 9]
    True
    """
    c=0
    nb = len(L)
    for en_cours in range(0,nb):    
        plus_petit = en_cours
        for j in range(en_cours+1,nb) :
            if L[j] < L[plus_petit] :#comparaison
                plus_petit = j
                c+=1
        if min is not en_cours :
            temp = L[en_cours]
            L[en_cours] = L[plus_petit]
            L[plus_petit] = temp
            c+=1
    return L,c

def tri_insertion(L):
    """1 seul argument qui est un tableau ou une liste , L
    la fonction renvoie (return) la liste L triée
    Test :
    L = [3, 1, 4, 1, 5, 9, 2]
    tri_insertion(L)
    L == [1, 1, 2, 3, 4, 5, 9]
    True
    """
    for i in range(1,len(L)):
        en_cours = L[i]
        j = i #décalage des éléments du tableau 
        while j>0 and L[j-1]>en_cours:#comparaison
            L[j]=L[j-1]
            j = j-1 #on insère l'élément à sa place
        L[j]=en_cours
    return L
    



def trirapide(L):
    """trirapide(L): tri rapide (quicksort) de la liste L"""
    def trirap(L, g, d):
        pivot = L[(g+d)//2]
        i = g
        j = d
        while True:
            while L[i]<pivot:
                i+=1
            while L[j]>pivot:
                j-=1
            if i>j:
                break
            if i<j:
                L[i], L[j] = L[j], L[i]
            i+=1
            j-=1
        if g<j:
            trirap(L,g,j)
        if i<d:
            trirap(L,i,d)
 
    g=0
    d=len(L)-1
    trirap(L,g,d) 
    
def fusion(Liste_gauche,Liste_droite): 
 
    resultat = [] #inatiation de la liste resultat
    index_gauche, index_droite = 0, 0
    while index_gauche < len(Liste_gauche) and index_droite < len(Liste_droite):
 
        if Liste_gauche[index_gauche] <= Liste_droite[index_droite]:
            resultat.append(Liste_gauche[index_gauche])
            index_gauche += 1
 
        else:
            resultat.append(Liste_droite[index_droite])
            index_droite += 1
 
    if Liste_gauche:
        resultat.extend(Liste_gauche[index_gauche:])
 
    if Liste_droite:
        resultat.extend(Liste_droite[index_droite:])
    return resultat
  
def tri_fusion(L):
 
    if len(L) <= 1:
        return L
 
    milieu = len(L) // 2
 
    #decoupe de la liste L en deux sous liste Liste_gauche et Liste_droite
    Liste_gauche = L[:milieu] 
    Liste_droite = L[milieu:]
     
    Liste_gauche = tri_fusion(Liste_gauche)# la même chose pour Liste_gauche
    Liste_droite = tri_fusion(Liste_droite)# la même chose pour Liste_droite
     
    return fusion(Liste_gauche, Liste_droite) #fusionner Liste_gauche et Liste_droite

#Création d'une liste trièe dans l'ordre croissant de nb valeur
def liste_triee(nb):
    '''1 argument qui est le nombre d'élément de la liste, nb
    la fonction renvoie une liste triée'''
    nmax=nb
    L=[]
    for i in range(0,nmax):
        L.append(i) 
    return L
    
# fabrication d'une liste de nb valeurs aléatoires
def liste_aleatoire(nb):
    '''1 argument qui est le nombre d'élément de la liste, nb
    la fonction renvoie une liste aléatoire'''
    nmax=nb
    L=[]
    for i in range(0,nmax):
        L.append(random.randint(0,nmax)) #creer une liste aléatoire de nmax valeur comprise entre 3600 et 10800
    return L
    
#↨L=liste_triee(1000)


L=liste_aleatoire(10000)
L1=list(L)
L2=list(L)
L3=list(L)

# tri selection avec affichage du temps passé
#print(L)
debut_chrono=time.time()
tri_selection(L)
temps_exe=time.time()-debut_chrono
print("nombre de valeur =",len(L))
print("temps execution tri selection",temps_exe)


# tri insertion avec affichage du temps passé
#print(L1)
debut_chrono=time.time()
tri_insertion(L1)
temps_exe=time.time()-debut_chrono
print("nombre de valeur =",len(L))
print("temps execution tri insertion",temps_exe)
 
# tri rapide avec affichage du temps passé
#print(L2)
debut_chrono=time.time()
trirapide(L2)
temps_exe=time.time()-debut_chrono
print("nombre de valeur =",len(L))
print("temps execution tri rapide =",temps_exe)

# tri fusion avec affichage du temps passé
#print(L3)
debut_chrono=time.time()
tri_fusion(L3)
temps_exe=time.time()-debut_chrono
print("nombre de valeur =",len(L))
print("temps execution tri fusion =",temps_exe)


